#include <afxwin.h>
#include <stdio.h>
#include "defines.h"
#include "rc\resource.h"
#include "ufo.h"

// ------------------------------- UFO 


void Ufo::Move(CBitmap *Pozadi, RECT rect, CDC *pDC, CPoint enemy) {
	// hraje pocitac
	if( ((abs(p_ufo.x - p_dest.x)<SPEED && abs(p_ufo.y - p_dest.y)<SPEED) || (moved == false))&&
		 (automat == true)) SetDestination();

	p_ufo_old = p_ufo;
	if (lives > 0) {
	// presun ufa - X
	if ((p_ufo.x < p_dest.x)&&(p_ufo.x < kraj.right)&&
		((abs(enemy.x-p_ufo.x) > BMPX+2*SPEED)||(enemy.x<p_ufo.x)||(abs(enemy.y-p_ufo.y) > BMPY+SPEED))) p_ufo.x+=SPEED;
   if ((p_ufo.x > p_dest.x)&&(p_ufo.x > kraj.left)&&
		((abs(enemy.x-p_ufo.x) > BMPX+2*SPEED)||(enemy.x>p_ufo.x)||(abs(enemy.y-p_ufo.y) > BMPY+SPEED))) p_ufo.x-=SPEED;
   // - Y
	if ((p_ufo.y < p_dest.y)&&(p_ufo.y < kraj.bottom)&&
		((abs(enemy.y-p_ufo.y) > BMPY+2*SPEED)||(enemy.y<p_ufo.y)||(abs(enemy.x-p_ufo.x) > BMPX+SPEED))) p_ufo.y+=SPEED;
	if ((((p_ufo.y > p_dest.y)&&(p_ufo.y > kraj.top+SPEED))||(p_ufo.y > kraj.bottom))&&
		((abs(enemy.y-p_ufo.y) > BMPY+2*SPEED)||(enemy.y>p_ufo.y)||(abs(enemy.x-p_ufo.x) > BMPX+SPEED))) p_ufo.y-=SPEED; 

	if(p_ufo.y < kraj.top+SPEED) p_ufo.y = kraj.top+SPEED;
	// aby kdyz hrajou dva pocitace se nezasekly
	if (p_ufo_old == p_ufo) moved = false;
	else moved = true;
	} // 	if (lives > 0) 


	if (auto_shoot < SHOOT_TIME) auto_shoot++;

	// presun strel
	for (int i = 0; i< 5; i++) 
		if (Is_shoot_valid(strely[i])) 
		{
			strely[i].place.x += strely[i].speed_x;
			strely[i].place.y += strely[i].speed_y;
		}
		else if((lives > 0)&&(automat==true)) {
		// streleni
			if (abs(p_ufo.x-enemy.x)/SHOOT_SPEED > abs(p_ufo.y - enemy.y)/SPEED_VERTICAL) st_task = TASK_LR;
				else if (p_ufo.y < enemy.y) st_task = TASK_DN;
					  else st_task = TASK_UP;
		}
	
	// strelba
	if (st_task == TASK_LR) Shoot();
	if (st_task == TASK_DN) ShootDn();
	if (st_task == TASK_UP) ShootUp();

	st_task = TASK_NO;
	return;

}

bool Ufo::Is_shoot_valid(Strela strela)
{
/*	if ((strela.place.x > PLOCHAX+ST_X_MAX) || (strela.place.x < -ST_X_MAX) ||
		(strela.place.y > PLOCHAY) || (strela.place.y <= 0)) return false;
	else return true;
	*/
	if(strela.place.x != INVALIDE_X_POINT) return true;
	else return false;
}


void Ufo::Shoot() {
	
	if ((auto_shoot < SHOOT_TIME)||(lives < 0)) return;

	int i = 0;
	for(i = 0; i < 5; i++) if((abs(strely[i].place.x - p_ufo.x) < 2*STX+BMPX/2)&&(abs(p_ufo.y-strely[i].place.y)<2*STY)) return;

	i = 0;
	while((i < 5)&& Is_shoot_valid(strely[i])) i++;
	if (Is_shoot_valid(strely[i])) return;
	
	strely[i].black_bmp = 1;
	strely[i].color_bmp = 0;
	strely[i].speed_x = speed_shoot;
	strely[i].speed_y = 0;
	strely[i].bmpx = STX;
	strely[i].bmpy = STY;
	strely[i].demage_x = DEMAGE_X;
	strely[i].demage_y = DEMAGE_Y;
	strely[i].place.y = p_ufo.y;
	strely[i].place.x = p_ufo.x + (speed_shoot/abs(speed_shoot))*(BMPX/2 + STX/2) + speed_shoot;
	strely[i].place_old = strely[i].place;
	auto_shoot = 0;
}

void Ufo::ShootUp() {

	if ((auto_shoot < SHOOT_TIME)||(lives < 0)) return;

	int i;

	// moc nahore nelze strilet
	if (p_ufo.y - STY_UP/2 - BMPY/2 <= HLADINA_NAHORE) return;
	// aby nebylo vice strel v sobe
	for(i = 0; i < 5; i++) if((abs(p_ufo.y - strely[i].place.y) < 2*STY_UP+BMPY/2)&&(p_ufo.y > strely[i].place.y)&&(abs(p_ufo.x-strely[i].place.x)<STX_UP)) return;
	
	i = 0;
	while((i < 5)&& Is_shoot_valid(strely[i])) i++;
	if (Is_shoot_valid(strely[i])) return;
	
	strely[i].black_bmp = 3;
	strely[i].color_bmp = 2;
	strely[i].speed_x = 0;
	strely[i].speed_y = SPEED_UP;
	strely[i].bmpx = STX_UP;
	strely[i].bmpy = STY_UP;
	strely[i].demage_x = DEMAGE_X_UP;
	strely[i].demage_y = DEMAGE_Y_UP;
	strely[i].place.y = p_ufo.y - STY_UP/2 - BMPY/2 - 1 + SPEED_UP;
	strely[i].place.x = p_ufo.x;
	strely[i].place_old = strely[i].place;
	auto_shoot = 0;
}


void Ufo::ShootDn() {

	if ((auto_shoot < SHOOT_TIME)||(lives < 0)) return;

	// aby nebylo vice strel v sobe
	int i;
	for(i = 0; i < 5; i++) if((strely[i].place.y - p_ufo.y < 2*STY_DN+BMPY/2+SPEED_DN)&&(p_ufo.y < strely[i].place.y)&&(abs(p_ufo.x-strely[i].place.x)<STX_DN)) return;

	i = 0;
	while((i < 5)&& Is_shoot_valid(strely[i])) i++;
	if (Is_shoot_valid(strely[i])) return;
	
	strely[i].black_bmp = 5;
	strely[i].color_bmp = 4;
	strely[i].speed_x = 0;
	strely[i].speed_y = SPEED_DN;
	strely[i].bmpx = STX_DN;
	strely[i].bmpy = STY_DN;
	strely[i].demage_x = DEMAGE_X_DN;
	strely[i].demage_y = DEMAGE_Y_DN;
	strely[i].place.y = p_ufo.y + STY_DN/2 + BMPY/2 + SPEED_DN;
	strely[i].place.x = p_ufo.x;
	strely[i].place_old = strely[i].place;
	auto_shoot = 0;
}

void Ufo::SetDestination() {
	p_dest.x = Nahoda(kraj.right-kraj.left) + kraj.left;
	p_dest.y = Nahoda(kraj.bottom-kraj.top) + kraj.top;
	return;
}

void Ufo::Zobraz(CBitmap *Pozadi, RECT rect, CDC *pDC) {
	CDC dc;
	CDC cdc;

	dc.CreateCompatibleDC(pDC);
	cdc.CreateCompatibleDC(pDC);

	CBitmap *p_dc = dc.SelectObject(vlozit);
	CBitmap *p_cdc = cdc.SelectObject(Pozadi);

	
	dc.BitBlt(0, 0, 2*SPEED+BMPX+2, 2*SPEED+BMPY+2, &cdc, p_ufo.x-((2*SPEED+BMPX+2)/2), p_ufo.y-((2*SPEED+BMPY+2)/2) ,SRCCOPY);

	cdc.SelectObject(m_pUfo_black);
	dc.BitBlt(1+SPEED,1+SPEED,BMPX,BMPY,&cdc,0,0,SRCAND);
	cdc.SelectObject(m_pUfo);
	dc.BitBlt(1+SPEED,1+SPEED,BMPX,BMPY,&cdc,0,0,SRCPAINT);
	pDC->StretchBlt((p_ufo.x-((2*SPEED+BMPX+2)/2))*rect.right/PLOCHAX ,(p_ufo.y-((2*SPEED+BMPY+2)/2))*rect.bottom/PLOCHAY, (2*SPEED+BMPX+2)*rect.right/PLOCHAX, (2*SPEED+BMPY+2)*rect.bottom/PLOCHAY, &dc, 0, 0,(2*SPEED+BMPX+2), (2*SPEED+BMPY+2),SRCCOPY);


	cdc.SelectObject(p_cdc);
	dc.SelectObject(p_dc);
   
}

void Ufo::Zobraz_strely(CBitmap *Pozadi, RECT rect, CDC *pDC)
{
	CDC dc;
	CDC cdc;
	int j;

	dc.CreateCompatibleDC(pDC);
	cdc.CreateCompatibleDC(pDC);

	CBitmap *p_dc = dc.SelectObject(vlozit);
	CBitmap *p_cdc = cdc.SelectObject(Pozadi);


	for (int i = 0; i < 5; i++)
		if (Is_shoot_valid(strely[i])) {
			cdc.SelectObject(Pozadi);
			if (strely[i].speed_x >= 0) j = 0;
			else j = 1;
			
			// zjistreni obdelnika a mista, kam placnout bitmapu
			CRect RRect;
			CPoint point;
	
			RRect.SetRect(strely[i].place.x-strely[i].bmpx/2 -2,
							  strely[i].place.y-strely[i].bmpy/2 -2,
							  strely[i].place.x+strely[i].bmpx/2 +2,
							  strely[i].place.y+strely[i].bmpy/2 +2);
			// pripadne prekresleni stare strely
			if (strely[i].place_old != strely[i].place) {
				if (strely[i].speed_y > 0) RRect.top -= abs(strely[i].speed_y);
				if (strely[i].speed_y < 0) RRect.bottom += abs(strely[i].speed_y);
				if (strely[i].speed_x > 0) RRect.left -= abs(strely[i].speed_x);
				if (strely[i].speed_x < 0) RRect.right += abs(strely[i].speed_x);
			}
			point.x = strely[i].place.x - RRect.left-strely[i].bmpx/2;
			point.y = strely[i].place.y - RRect.top-strely[i].bmpy/2;
			
			dc.BitBlt(0, 0, RRect.Width(),RRect.Height(), &cdc, RRect.left, RRect.top, SRCCOPY);
	
			cdc.SelectObject(m_pUfo_shoot[j][strely[i].black_bmp]);
			dc.BitBlt(point.x,point.y,strely[i].bmpx,strely[i].bmpy,&cdc,0,0,SRCAND);
		
			cdc.SelectObject(m_pUfo_shoot[j][strely[i].color_bmp]);
			dc.BitBlt(point.x,point.y,strely[i].bmpx,strely[i].bmpy,&cdc,0,0,SRCPAINT);

			pDC->StretchBlt(int((RRect.left)*rect.right/PLOCHAX),int((RRect.top)*rect.bottom/PLOCHAY),int((RRect.Width())*rect.right/PLOCHAX),int(RRect.Height()*rect.bottom/PLOCHAY),&dc,0,0,RRect.Width(),RRect.Height(),SRCCOPY);

			strely[i].place_old = strely[i].place;

/*	
			dc.BitBlt(0, 0, 2*abs(strely[i].speed_x)+strely[i].bmpx+2,2*abs(strely[i].speed_y)+strely[i].bmpy+2, &cdc, strely[i].place.x-abs(strely[i].speed_x)-strely[i].bmpx/2+1, strely[i].place.y-abs(strely[i].speed_y)-strely[i].bmpy/2, SRCCOPY);
			cdc.SelectObject(m_pUfo_shoot[j][strely[i].black_bmp]);
			dc.BitBlt(abs(strely[i].speed_x)+1,abs(strely[i].speed_y)+1,strely[i].bmpx,strely[i].bmpy,&cdc,0,0,SRCAND);
			cdc.SelectObject(m_pUfo_shoot[j][strely[i].color_bmp]);
			dc.BitBlt(abs(strely[i].speed_x)+1,abs(strely[i].speed_y)+1,strely[i].bmpx,strely[i].bmpy,&cdc,0,0,SRCPAINT);
			pDC->StretchBlt(int((strely[i].place.x-abs(strely[i].speed_x)-strely[i].bmpx/2+1)*rect.right/(PLOCHAX)),int((strely[i].place.y-abs(strely[i].speed_y)-strely[i].bmpy/2)*rect.bottom/(PLOCHAY)),int((2*abs(strely[i].speed_x)+strely[i].bmpx+2)*rect.right/(PLOCHAX)),int((2*abs(strely[i].speed_y)+strely[i].bmpy+2)*rect.bottom/(PLOCHAY)),&dc,0,0,2*abs(strely[i].speed_x)+strely[i].bmpx+2,2*abs(strely[i].speed_y)+strely[i].bmpy+2,SRCCOPY);

			dc.BitBlt(0, 0, 2*abs(strely[i].speed_x)+STX+2,2*abs(strely[i].speed_y)+STY+2, &cdc, strely[i].place.x-abs(strely[i].speed_x)-STX/2+1, strely[i].place.y-abs(strely[i].speed_y)-STY/2, SRCCOPY);
			dc.BitBlt(abs(strely[i].speed_x)+1,abs(strely[i].speed_y)+1,STX,STY,&cdc,0,0,SRCAND);
			dc.BitBlt(abs(strely[i].speed_x)+1,abs(strely[i].speed_y)+1,STX,STY,&cdc,0,0,SRCPAINT);
			pDC->StretchBlt(int((strely[i].place.x-abs(strely[i].speed_x)/2+1)*rect.right/(PLOCHAX)),int((strely[i].place.y-abs(strely[i].speed_y)-STY/2)*rect.bottom/(PLOCHAY)),int((2*abs(strely[i].speed_x)+STX+2)*rect.right/(PLOCHAX)),int((2*abs(strely[i].speed_y)+STY+2)*rect.bottom/(PLOCHAY)),&dc,0,0,2*abs(strely[i].speed_x)+STX+2,2*abs(strely[i].speed_y)+STY+2,SRCCOPY);

			dc.BitBlt(0, 0, 2*SHOOT_SPEED+STX+2,STY+2, &cdc, strely[i].place.x-SHOOT_SPEED-STX/2+1, strely[i].place.y-STY/2, SRCCOPY);
			dc.BitBlt(SHOOT_SPEED+1,1,STX,STY,&cdc,0,0,SRCAND);
			dc.BitBlt(SHOOT_SPEED+1,1,STX,STY,&cdc,0,0,SRCPAINT);
			pDC->StretchBlt(int((strely[i].place.x-SHOOT_SPEED-STX/2+1)*rect.right/(PLOCHAX)),int((strely[i].place.y-STY/2)*rect.bottom/(PLOCHAY)),int((2*SHOOT_SPEED+STX+2)*rect.right/(PLOCHAX)),int((STY+2)*rect.bottom/(PLOCHAY)),&dc,0,0,2*SHOOT_SPEED+STX+2,STY+2,SRCCOPY);
			
			*/
		}

	cdc.SelectObject(p_cdc);
	dc.SelectObject(p_dc);

}


// ------------------------------- UFO 1


Ufo1::Ufo1() {
	
	int i;

	
	kraj.top = LIVES_Y+BMPY;
	kraj.left = BMPX;
	kraj.right = PLOCHAX-BMPX;
	kraj.bottom = LETOVA_HLADINA;

	p_ufo.x = 170;
	p_ufo.y = 383;

	p_dest.x = 170;
	p_dest.y = 200;


	// normalni lod
	for(i = 0;i < 12; i++){
		m_animace[0][i] = new CBitmap;
		m_animace[1][i] = new CBitmap;
		m_animace_black[0][i] = new CBitmap;
		m_animace_black[1][i] = new CBitmap;
	}
	m_animace[0][0]->LoadBitmap(IDB_UFO1_0);
	m_animace[0][1]->LoadBitmap(IDB_UFO1_1);
	m_animace[0][2]->LoadBitmap(IDB_UFO1_2);
	m_animace[0][3]->LoadBitmap(IDB_W1);
	m_animace[0][4]->LoadBitmap(IDB_W2);
	m_animace[0][5]->LoadBitmap(IDB_W3);
	m_animace[0][6]->LoadBitmap(IDB_W4);
	m_animace[0][7]->LoadBitmap(IDB_W5);
	m_animace[0][8]->LoadBitmap(IDB_W6);
	m_animace[0][9]->LoadBitmap(IDB_W7);
	m_animace[0][10]->LoadBitmap(IDB_W8);

	m_animace[1][0]->LoadBitmap(IDB_UFO1_0_2);
	m_animace[1][1]->LoadBitmap(IDB_UFO1_1_2);
	m_animace[1][2]->LoadBitmap(IDB_UFO1_2_2);
	m_animace[1][3]->LoadBitmap(IDB_W1);
	m_animace[1][4]->LoadBitmap(IDB_W2);
	m_animace[1][5]->LoadBitmap(IDB_W3);
	m_animace[1][6]->LoadBitmap(IDB_W4);
	m_animace[1][7]->LoadBitmap(IDB_W5);
	m_animace[1][8]->LoadBitmap(IDB_W6);
	m_animace[1][9]->LoadBitmap(IDB_W7);
	m_animace[1][10]->LoadBitmap(IDB_W8);

	
	m_animace_black[0][0]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][1]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][2]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][3]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][4]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][5]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][6]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][7]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[0][8]->LoadBitmap(IDB_W8_B);
	m_animace_black[0][9]->LoadBitmap(IDB_W8_B);
	m_animace_black[0][10]->LoadBitmap(IDB_W8_B);

	m_animace_black[1][0]->LoadBitmap(IDB_UFO1_1_2_B);
	m_animace_black[1][1]->LoadBitmap(IDB_UFO1_1_2_B);
	m_animace_black[1][2]->LoadBitmap(IDB_UFO1_1_2_B);
	m_animace_black[1][3]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[1][4]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[1][5]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[1][6]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[1][7]->LoadBitmap(IDB_UFO1_1B);
	m_animace_black[1][8]->LoadBitmap(IDB_W8_B);
	m_animace_black[1][9]->LoadBitmap(IDB_W8_B);
	m_animace_black[1][10]->LoadBitmap(IDB_W8_B);

	m_pUfo = m_animace[0][0];
	m_pUfo_black = m_animace_black[0][0];

	
	// strely
	for(i = 0; i < 6; i++) {
	m_pUfo_shoot[0][i] = new CBitmap;
	m_pUfo_shoot[1][i] = new CBitmap;
	}
	m_pUfo_shoot[0][0]->LoadBitmap(IDB_STRELA1);
	m_pUfo_shoot[0][1]->LoadBitmap(IDB_STRELA1_BLACK);
	m_pUfo_shoot[1][0]->LoadBitmap(IDB_STRELA1_2);
	m_pUfo_shoot[1][1]->LoadBitmap(IDB_STRELA1_BLACK_2);

	m_pUfo_shoot[0][2]->LoadBitmap(IDB_STRELA1_UP);
	m_pUfo_shoot[0][3]->LoadBitmap(IDB_STRELA1_UP_B);
	m_pUfo_shoot[1][2]->LoadBitmap(IDB_STRELA1_UP);
	m_pUfo_shoot[1][3]->LoadBitmap(IDB_STRELA1_UP_B);

	m_pUfo_shoot[0][4]->LoadBitmap(IDB_STRELA1_DN);
	m_pUfo_shoot[0][5]->LoadBitmap(IDB_STRELA1_DN_B);
	m_pUfo_shoot[1][4]->LoadBitmap(IDB_STRELA1_DN);
	m_pUfo_shoot[1][5]->LoadBitmap(IDB_STRELA1_DN_B);


	// zasahy
	for (i = 0; i < 3; i++) {
		m_hit[0][i] = new CBitmap;
		m_hit[1][i] = new CBitmap;
	}
	m_hit[0][0]->LoadBitmap(IDB_UFO1_H0);
	m_hit[1][0]->LoadBitmap(IDB_UFO1_H0_2);
	m_hit[0][1]->LoadBitmap(IDB_UFO1_H1);
	m_hit[1][1]->LoadBitmap(IDB_UFO1_H1_2);
	m_hit[0][2]->LoadBitmap(IDB_UFO1_H2);
	m_hit[1][2]->LoadBitmap(IDB_UFO1_H2_2);

	for (i = 0; i < 5; i++) strely[i].place.x = -20;
	speed_shoot = SHOOT_SPEED;

}

Ufo1::~Ufo1() {
	for(int i = 0;i < 12; i++){
		delete m_animace[0][i];
		delete m_animace[1][i];
		delete m_animace_black[0][i];
		delete m_animace_black[1][i];
	}
	
	for(i = 0; i < 6; i++) {
	delete m_pUfo_shoot[0][i];
	delete m_pUfo_shoot[1][i];
	}

	for (i = 0; i < 3; i++) {
		delete m_hit[0][i];
		delete m_hit[1][i];
	}


	if(automat == true) AfxGetApp()->WriteProfileInt("Hra","PL1",1);
	else AfxGetApp()->WriteProfileInt("Hra","PL1",0);

}

void Ufo1::Reset()
{

	lives = LIVES;

	p_ufo.x = 170;
	p_ufo.y = 383;

	p_dest.x = 170;
	p_dest.y = 200;

	for (int i = 0; i < 5; i++) {
		strely[i].place.x = INVALIDE_X_POINT;
		strely[i].place.y = 0;
	};

	moved = false;

	m_pUfo = m_animace[0][0];
	m_pUfo_black = m_animace_black[0][0];

	auto_shoot = SHOOT_TIME;
}


// ------------------------------- UFO 2

Ufo2::Ufo2() {
	int i;
	

	kraj.top = LIVES_Y+BMPY;
	kraj.left = BMPX;
	kraj.right = PLOCHAX-BMPX;
	kraj.bottom = LETOVA_HLADINA;

	p_ufo.x = 426;
	p_ufo.y = 380;

	p_dest.x = 426;
	p_dest.y = 200;

	for(i = 0;i < 12; i++){
		m_animace[0][i] = new CBitmap;
		m_animace[1][i] = new CBitmap;
		m_animace_black[0][i] = new CBitmap;
		m_animace_black[1][i] = new CBitmap;
	}
	m_animace[0][0]->LoadBitmap(IDB_UFO2_0);
	m_animace[0][1]->LoadBitmap(IDB_UFO2_1);
	m_animace[0][2]->LoadBitmap(IDB_UFO2_2);
	m_animace[0][3]->LoadBitmap(IDB_R1);
	m_animace[0][4]->LoadBitmap(IDB_R2);
	m_animace[0][5]->LoadBitmap(IDB_R3);
	m_animace[0][6]->LoadBitmap(IDB_R4);
	m_animace[0][7]->LoadBitmap(IDB_R5);
	m_animace[0][8]->LoadBitmap(IDB_R6);
	m_animace[0][9]->LoadBitmap(IDB_R7);
	m_animace[0][10]->LoadBitmap(IDB_R8);

	m_animace[1][0]->LoadBitmap(IDB_UFO2_0_2);
	m_animace[1][1]->LoadBitmap(IDB_UFO2_1_2);
	m_animace[1][2]->LoadBitmap(IDB_UFO2_2_2);
	m_animace[1][3]->LoadBitmap(IDB_R1);
	m_animace[1][4]->LoadBitmap(IDB_R2);
	m_animace[1][5]->LoadBitmap(IDB_R3);
	m_animace[1][6]->LoadBitmap(IDB_R4);
	m_animace[1][7]->LoadBitmap(IDB_R5);
	m_animace[1][8]->LoadBitmap(IDB_R6);
	m_animace[1][9]->LoadBitmap(IDB_R7);
	m_animace[1][10]->LoadBitmap(IDB_R8);

	m_animace_black[0][0]->LoadBitmap(IDB_UFO2_0B);
	m_animace_black[0][1]->LoadBitmap(IDB_UFO2_1B);
	m_animace_black[0][2]->LoadBitmap(IDB_UFO2_2B);
	m_animace_black[0][3]->LoadBitmap(IDB_R1_B);
	m_animace_black[0][4]->LoadBitmap(IDB_R2_B);
	m_animace_black[0][5]->LoadBitmap(IDB_R3_B);
	m_animace_black[0][6]->LoadBitmap(IDB_R4_B);
	m_animace_black[0][7]->LoadBitmap(IDB_R5_B);
	m_animace_black[0][8]->LoadBitmap(IDB_R6_B);
	m_animace_black[0][9]->LoadBitmap(IDB_R7_B);
	m_animace_black[0][10]->LoadBitmap(IDB_W8_B);

	m_animace_black[1][0]->LoadBitmap(IDB_UFO2_0_2_B);
	m_animace_black[1][1]->LoadBitmap(IDB_UFO2_0_2_B);
	m_animace_black[1][2]->LoadBitmap(IDB_UFO2_0_2_B);
	m_animace_black[1][3]->LoadBitmap(IDB_R1_B);
	m_animace_black[1][4]->LoadBitmap(IDB_R2_B);
	m_animace_black[1][5]->LoadBitmap(IDB_R3_B);
	m_animace_black[1][6]->LoadBitmap(IDB_R4_B);
	m_animace_black[1][7]->LoadBitmap(IDB_R5_B);
	m_animace_black[1][8]->LoadBitmap(IDB_R6_B);
	m_animace_black[1][9]->LoadBitmap(IDB_R7_B);
	m_animace_black[1][10]->LoadBitmap(IDB_W8_B);

	
	
	m_pUfo = m_animace[0][0];
	m_pUfo_black = m_animace_black[0][0];

	for(i = 0; i < 6; i++) {
	m_pUfo_shoot[0][i] = new CBitmap;
	m_pUfo_shoot[1][i] = new CBitmap;
	}
	m_pUfo_shoot[0][0]->LoadBitmap(IDB_STRELA2_2);
	m_pUfo_shoot[0][1]->LoadBitmap(IDB_STRELA2_BLACK_2);
	m_pUfo_shoot[1][0]->LoadBitmap(IDB_STRELA2);
	m_pUfo_shoot[1][1]->LoadBitmap(IDB_STRELA2_BLACK);

	m_pUfo_shoot[0][2]->LoadBitmap(IDB_STRELA2_UP);
	m_pUfo_shoot[0][3]->LoadBitmap(IDB_STRELA2_UP_B);
	m_pUfo_shoot[1][2]->LoadBitmap(IDB_STRELA2_UP);
	m_pUfo_shoot[1][3]->LoadBitmap(IDB_STRELA2_UP_B);

	m_pUfo_shoot[0][4]->LoadBitmap(IDB_STRELA2_DN);
	m_pUfo_shoot[0][5]->LoadBitmap(IDB_STRELA2_DN_B);
	m_pUfo_shoot[1][4]->LoadBitmap(IDB_STRELA2_DN);
	m_pUfo_shoot[1][5]->LoadBitmap(IDB_STRELA2_DN_B);


	// zasahy
	for (i = 0; i < 3; i++) {
		m_hit[0][i] = new CBitmap;
		m_hit[1][i] = new CBitmap;
	}
	m_hit[0][0]->LoadBitmap(IDB_UFO2_H0);
	m_hit[1][0]->LoadBitmap(IDB_UFO2_H0_2);
	m_hit[0][1]->LoadBitmap(IDB_UFO2_H1);
	m_hit[1][1]->LoadBitmap(IDB_UFO2_H1_2);
	m_hit[0][2]->LoadBitmap(IDB_UFO2_H2);
	m_hit[1][2]->LoadBitmap(IDB_UFO2_H2_2);


	for (i = 0; i < 5; i++) strely[i].place.x = -20;
	speed_shoot = -SHOOT_SPEED;

}

Ufo2::~Ufo2() {
	for(int i = 0;i < 12; i++){
		delete m_animace[0][i];
		delete m_animace[1][i];
		delete m_animace_black[0][i];
		delete m_animace_black[1][i];
	}

	for(i = 0; i < 6; i++) {
	delete m_pUfo_shoot[0][i];
	delete m_pUfo_shoot[1][i];
	}

	for (i = 0; i < 3; i++) {
		delete m_hit[0][i];
		delete m_hit[1][i];
	}

	if(automat == true) AfxGetApp()->WriteProfileInt("Hra","PL2",1);
	else AfxGetApp()->WriteProfileInt("Hra","PL2",0);

}



void Ufo2::Reset()
{
	lives = LIVES;
	
	p_ufo.x = 426;
	p_ufo.y = 380;

	p_dest.x = 426;
	p_dest.y = 200;

	for (int i = 0; i < 5; i++) { 
		strely[i].place.x = INVALIDE_X_POINT;
		strely[i].place.y = 0;
	};

	m_pUfo = m_animace[0][0];
	m_pUfo_black = m_animace_black[0][0];
	
	moved = false;

	auto_shoot = SHOOT_TIME;
}

Ufo::Init(CDC *pDC)
{
	vlozit = new CBitmap;
	vlozit->CreateCompatibleBitmap(pDC,MAX_BMPX,MAX_BMPY);
	for(int i = 0; i < 5; i++)	strely[i].place.x = INVALIDE_X_POINT;
}

bool Ufo::Test(CBitmap *Pozadi, RECT rect, CDC *pDC, Ufo *pl2, int an)
{
	int i;
	bool kresli = false;

	for (i = 0; i < 5; i++) {
		if((abs(strely[i].place.x - pl2->p_ufo.x) <= BMPX/2+strely[i].bmpx) &&
			(abs(strely[i].place.y - pl2->p_ufo.y) <= BMPY/2+strely[i].bmpy)) {
			if (pl2->lives > 0) {
				pl2->lives -= strely[i].demage_x -abs(strely[i].place.x - pl2->p_ufo.x) + strely[i].demage_y - abs(strely[i].place.y - pl2->p_ufo.y);
				if (pl2->lives < 0) pl2->lives = 0;
				// Predelani bitmapy - se zasahem 
				pl2->m_pUfo = pl2->m_hit[an][Nahoda(3)];
				kresli = true;
			}
			Zamaluj_strelu(pDC,rect,Pozadi,strely[i].place_old,strely[i].bmpx,strely[i].bmpy);
			strely[i].place.x = INVALIDE_X_POINT; // zneplatneni strely
		}
		if ((lives <= -50)||(strely[i].place.y <= HLADINA_NAHORE)||(strely[i].place.y >= HLADINA_ZAKLADEN)
			||(strely[i].place_old.x >= PLOCHAX+strely[i].bmpx)||(strely[i].place_old.x <= -strely[i].bmpx)) {
			Zamaluj_strelu(pDC,rect,Pozadi,strely[i].place_old,strely[i].bmpx,strely[i].bmpy);
			strely[i].place.x = INVALIDE_X_POINT; // zneplatneni strely
		}
	}
	return kresli;
}

Ufo::~Ufo() {
	delete vlozit;
}

//*********************** METEOR

Meteor::Meteor()
{
	int i;
	color_ex = 8;
	black_ex = 8;

	for (i = 0; i < 9; i++){
		anim[i] = new CBitmap;
		anim_b[i] = new CBitmap;
	}
	anim[0]->LoadBitmap(IDB_METEOR0);
	anim[1]->LoadBitmap(IDB_METEOR0);
	anim[2]->LoadBitmap(IDB_METEOR0);
	anim[3]->LoadBitmap(IDB_METEOR0);
	anim[4]->LoadBitmap(IDB_METEOR0);
	anim[5]->LoadBitmap(IDB_METEOR_H0);
	anim[6]->LoadBitmap(IDB_METEOR_H1);
	anim[7]->LoadBitmap(IDB_METEOR_H2);
	anim[8]->LoadBitmap(IDB_METEOR_EX);
	

	anim_b[0]->LoadBitmap(IDB_METEOR0_B);
	anim_b[1]->LoadBitmap(IDB_METEOR0_B);
	anim_b[2]->LoadBitmap(IDB_METEOR0_B);
	anim_b[3]->LoadBitmap(IDB_METEOR0_B);
	anim_b[4]->LoadBitmap(IDB_METEOR0_B);
	anim_b[5]->LoadBitmap(IDB_METEOR0_B);
	anim_b[6]->LoadBitmap(IDB_METEOR0_B);
	anim_b[7]->LoadBitmap(IDB_METEOR0_B);
	anim_b[8]->LoadBitmap(IDB_METEOR0_B);

	Reset();
}

Meteor::~Meteor()
{
	int i;
	for (i = 0; i < 9; i++){
		delete anim[i];
		delete anim_b[i];
	}

}

void Meteor::Zobraz(CBitmap *Pozadi, RECT rect, CDC *pDC)
{
	CDC dc;
	CDC cdc;
	static int j = 0;
	static int jj = 0; // zpozdeni animace

	if (stav == HIT) { j = 5 + Nahoda(3); jj = 0; }
	if (stav == EXPLODE) { j = 8; jj = 0; }

	CBitmap *vlozit;
	vlozit = new CBitmap;
	vlozit->CreateCompatibleBitmap(pDC,100,100);

	dc.CreateCompatibleDC(pDC);
	cdc.CreateCompatibleDC(pDC);

	CBitmap *p_dc = dc.SelectObject(vlozit);
	CBitmap *p_cdc = cdc.SelectObject(Pozadi);


	cdc.SelectObject(Pozadi);
	dc.BitBlt(0, 0, 2*abs(speed_x)+bmpx+2,2*abs(speed_y)+bmpy+2, &cdc, place.x-abs(speed_x)-bmpx/2+1, place.y-abs(speed_y)-bmpy/2, SRCCOPY);
		
	cdc.SelectObject(anim_b[j]);
	dc.BitBlt(abs(speed_x)+1,abs(speed_y)+1,bmpx,bmpy,&cdc,0,0,SRCAND);
		
	cdc.SelectObject(anim[j]);
	dc.BitBlt(abs(speed_x)+1,abs(speed_y)+1,bmpx,bmpy,&cdc,0,0,SRCPAINT);
		
	pDC->StretchBlt(int((place.x-abs(speed_x)-bmpx/2+1)*rect.right/(PLOCHAX)),int((place.y-abs(speed_y)-bmpy/2)*rect.bottom/(PLOCHAY)),int((2*abs(speed_x)+bmpx+2)*rect.right/(PLOCHAX)),int((2*abs(speed_y)+bmpy+2)*rect.bottom/(PLOCHAY)),&dc,0,0,2*abs(speed_x)+bmpx+2,2*abs(speed_y)+bmpy+2,SRCCOPY);


	cdc.SelectObject(p_cdc);
	dc.SelectObject(p_dc);

	delete vlozit;

	if (++jj%5 == 0) if(++j >= 1) j = 0;
	if (stav == EXPLODE) j = 0;
	stav = NORMAL;

}

void Meteor::Move(CDC *dc, CRect rect, CBitmap *pozadi)
{
	if((place.x > PLOCHAX+MT_X/2)||(place.x < -MT_X/2)||(place.y > HLADINA_ZAKLADEN)||(hits <= 0)) {
		Zamaluj_strelu(dc,rect,pozadi, place, bmpx, bmpy);
		Reset();
	}
	else {
		place_old = place;
		place.x += speed_x;
		place.y += speed_y;
		if (place.y > HLADINA_ZAKLADEN) stav = EXPLODE;
	}
}

void Meteor::Reset()
{
	hits = MT_MAX_HITS;
	speed_x = Nahoda(2*SPEED_MT_X_MAX) - SPEED_MT_X_MAX;
	speed_y = Nahoda(SPEED_MT_Y_MAX) + 2;
	bmpx = MT_X;
	bmpy = MT_Y;
	demage_x = DEMAGE_X_MT;
	demage_y = DEMAGE_Y_MT;
	if (speed_x < 0) place.x = Nahoda(PLOCHAX/2) + PLOCHAX/2;
	else place.x = Nahoda(PLOCHAX/2);
	place.y = HLADINA_NAHORE+MT_Y/2;
	place_old = place;
	stav = NORMAL;
}

bool Meteor::Test(CBitmap *Pozadi, RECT rect, CDC *pDC, Ufo *hrac, int an)
{
	int i;
	bool kresli = false;


	if((abs(place.x - hrac->p_ufo.x) <= BMPX/2+bmpx) &&
		(abs(place.y - hrac->p_ufo.y) <= BMPY/2+bmpy)) {
		if (hrac->lives > 0) {
			hrac->lives -= demage_x -abs(place.x - hrac->p_ufo.x) + demage_y - abs(place.y - hrac->p_ufo.y);
			if (hrac->lives < 0) hrac->lives = 0;
			// Predelani bitmapy - se zasahem 
			hrac->m_pUfo = hrac->m_hit[an][Nahoda(3)];
			kresli = true;
		}
		Zamaluj_strelu(pDC,rect,Pozadi,place_old,bmpx,bmpy);
		Reset(); // zneplatnei strely
	}
	
	for (i = 0; i < 5; i++)
		if((abs(place.x - hrac->strely[i].place.x) <= hrac->strely[i].bmpx/2+bmpx) &&
			(abs(place.y - hrac->strely[i].place.y) <= hrac->strely[i].bmpy/2+bmpy)) {
			Zamaluj_strelu(pDC,rect,Pozadi,hrac->strely[i].place_old, hrac->strely[i].bmpx, hrac->strely[i].bmpy);
			hrac->strely[i].place.x = INVALIDE_X_POINT; // zneplatnei strely
			hits--;
			stav = HIT;
			if (hits == 0) stav = EXPLODE;
		}
	
	return kresli;
}
