// ufo1.h

// omazeni pro strely
#define KRAJX1  (0 - STX)
#define KRAJX2  (PLOCHAX + STX)
#define KRAJY1  (0 - STY)
#define KRAJY2  (PLOCHAX + STY)

// pozadavky na vystreleni
#define TASK_NO 0 
#define TASK_UP 1
#define TASK_DN 2
#define TASK_LR 3  

int Nahoda(int nrOfSides);

class Strela {
public :	
	CPoint place; // souradnice strely
	CPoint place_old; // minula souradnice strely 
	int speed_x; // smer a rychlost pohybu v X
	int speed_y; // smer a rychlost pohybu v Y
	int bmpx; // rozmery bitmapy
	int bmpy;
	int color_bmp;	// cislo bmp v poili
	int black_bmp;
	int color_ex; // cislo explozni bitmapy
	int black_ex;
	int demage_x; // nicivost
	int demage_y;
};

class Ufo {
public : 
	bool Is_shoot_valid(Strela strela);
	bool Test(CBitmap *Pozadi, RECT rect, CDC *pDC, Ufo *pl2, int an);
	void Zobraz_strely(CBitmap *Pozadi, RECT rect, CDC *pDC);
	Init(CDC *pDC);
	~Ufo();
	CPoint p_ufo;  // souradnice ufa
	CPoint p_ufo_old;  // minula souradnice ufa
	CPoint p_dest; // souradnice, kam se ma letet
	int speed_shoot;  // rychlost strely - a smer, kam se ma strilet;
	void Move(CBitmap *Pozadi, RECT rect, CDC *pDC, CPoint enemy); // Ukazatel na pozadi 600*400, velikost client rect
	void Zobraz(CBitmap *Pozadi, RECT rect, CDC *pDC);
	void Shoot();  // prida strelu - vodorovne
	void ShootUp(); // prida strelu - nahoru
	void ShootDn(); // prida strelu - dolu
	RECT kraj; // definice, kde se ufo pohybuje
	bool automat; // pri zapnuti - Ufo funguje samo
	int lives; // zivoty
	int killed; // kolikrat uz byla raketa znicena
	int auto_shoot; // aby se nedalo strilet moc rychle v pripade, ze se lode dotykaji
   bool moved; // urcuje, zda se raketa pohla - aby se rakety nezasekly


	Strela strely[10];

	int st_task; // pozadavky na srtely - vystreleni

	// bitmapy

	CBitmap *vlozit; // pro Zobraz - aby se nemuselo stale zavadet

	CBitmap *m_pUfo;
	CBitmap *m_pUfo_black;
	CBitmap *m_pUfo_shoot[2][8]; 
	CBitmap *m_animace[2][15]; // pohyb lodi
	CBitmap *m_hit[2][6]; // zasah do lodi
	CBitmap *m_animace_black[2][15];
	void SetDestination();
};

class Ufo1 : public Ufo {
public :
	void Reset();
	Ufo1();
	~Ufo1();

};


class Ufo2 : public  Ufo {
public :
	void Reset();
	Ufo2();
	~Ufo2();
};

// stavy meteoru 
#define NORMAL 0
#define HIT    1
#define EXPLODE 2


class Meteor : public Strela {
public :
	bool Test(CBitmap *Pozadi, RECT rect, CDC *pDC, Ufo *hrac, int an);
	void Reset();
	void Move(CDC *dc, CRect rect, CBitmap *pozadi);
	void Zobraz(CBitmap *Pozadi, RECT rect, CDC *pDC);
	Meteor();
	~Meteor();

	int hits; // pocita,kolikrat se terfily do meteoru - pak zmizi ( po treba 5 )
	int stav;

	CBitmap *anim[10];
	CBitmap *anim_b[10];
};